#include "testlib.h"
#include <vector>
#include <algorithm>
#include <string>

using namespace std;

long long n;

struct point {
    long long x, y;
    point(int x, int y) : x(x), y(y) {}
    point() : x(0), y(0) {}
    point(point a, point b) : x(a.x - b.x), y(a.y - b.y) {}
};

long long cross_product(point& a, point& b) {
    return a.x * b.y - b.x * a.y;
}

vector<point> mas;

int check_outp(auto& stream) {
    string s = lowerCase(stream.readToken());
    if (s == "no") {
        return 0;
    }
    if (s == "yes") {
        long long a = stream.readLong(1, n, "a");
        long long b = stream.readLong(1, n, "b");
        long long c = stream.readLong(1, n, "c");
        if (a == b || a == c || b == c) {
            stream.quitf(_wa, "there aren't three points");
        }
        point p1(mas[b - 1],  mas[a - 1]);
        point p2(mas[c - 1],  mas[a - 1]);
        if (cross_product(p1, p2) == 0) {
            stream.quitf(_wa, "these vectors are collinear %lld %lld %lld %lld", p1.x, p1.y, p2.x, p2.y);
        }
        return 1;
    }
    stream.quitf(_wa, "first word isn't yes or no");
}

int main(int argc, char* argv[]) {
    registerTestlibCmd(argc, argv);
    n = inf.readLong();
    mas.resize(n);
    for (int i = 0; i < n; i++) {
        mas[i].x = inf.readLong();
        mas[i].y = inf.readLong();
    }
    int jans = check_outp(ans);
    int pans = check_outp(ouf);
    if (pans && !jans) {
        quitf(_fail, "expected no solution");
    }
    if (!pans && jans) {
        quitf(_wa, "expected 3 point");
    }
    if (pans && jans) {
        quitf(_ok, "found 3 points ok");
    }
    quitf(_ok, "found no points");
}
