#include <iostream>
#include <vector>
#include <random>
#include <chrono>

using namespace std;

struct point {
    long long x, y;
};

bool on_line(point const &a, point const &b, point const &c) {
    return (c.y - a.y) * (b.x - a.x) == (b.y - a.y) * (c.x - a.x);
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    unsigned int n;
    cin >> n;
    vector<point> points(n);
    for (unsigned int i = 0; i < n; i++) {
        cin >> points[i].x >> points[i].y;
    }

    mt19937 gen(chrono::system_clock::now().time_since_epoch().count());
    uniform_int_distribution<unsigned int> d(0, n - 1);
    for (unsigned int t = 0; t < 10000000; t++) {
        unsigned int i = d(gen), j = d(gen), k = d(gen);
        if (i != j && i != k && j != k && !on_line(points[i], points[j], points[k])) {
            cout << "Yes" << '\n' << i + 1 << ' ' << j + 1 << ' ' << k + 1 << '\n';
            return 0;
        }
    }

    cout << "No\n";

}
