#ifdef LOCAL
#include "../../testlib.h"
#else
#include "testlib.h"
#endif
#include <string>

using namespace std;

string gen_number(int len, bool zero = false) {
    string res;
    if (!zero) {
        res.push_back('0' + rnd.next(1, 9));
    } else {
        len += 1;
    }
    for (int i = 1; i < len; i++) {
        res.push_back('0' + rnd.next(10));
    }
    return res;
}

int digit_sum(string const &value) {
    int s = 0;
    for (char c : value) {
        s += c - '0';
    }
    return s % 9;
}

void minus1(string &res) {
    int idx = res.size() - 1;
    while (res[idx] == '0') {
        res[idx--] = '9';
    }
    res[idx]--;
}

void plus1(string &res) {
    int idx = res.size() - 1;
    while (res[idx] == '9') {
        res[idx--] = '0';
    }
    res[idx]++;
}

int main(int argc, char *argv[]) {

#ifdef LOCAL
    freopen("inf", "w", stdout);
#endif

    registerGen(argc, argv, 1);

    int from = atoi(argv[1]), to = atoi(argv[2]), sim = atoi(argv[3]);
    int n = 99999;

    string common = gen_number(sim);
    int cs = digit_sum(common), d = (from - cs + 9) % 9, add = to - from;
    if (add < 0) {
        add += 9;
    }
    if (add > 0) {
        while (d + add <= 9) {
            minus1(common);
            cs--;
            d++;
        }
    }

    string a = common;
    for (int i = sim; i < n - 1; i++) {
        a.push_back('9');
    }
    a.push_back('0' + d);

    string b = a;
    int mod = from;
    while (mod != to) {
        plus1(b);
        mod = (mod + 1) % 9;
    }

    println(a);
    println(b);

}
