// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;
int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937_64 tw(9450189);
#else
	mt19937_64 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif

struct hsh {
	ull a, b, c;
	hsh() : a(0), b(0), c(0) {}
	hsh(ull _a, ull _b, ull _c) : a(_a), b(_b), c(_c) {}

	hsh operator^(hsh const& other) const {
		return hsh(a ^ other.a, b ^ other.b, c ^ other.c);
	}

	bool operator<(hsh const& other) const {
		return make_tuple(a, b, c) < make_tuple(other.a, other.b, other.c);
	}

	hsh& operator^=(hsh const& other) {
		a ^= other.a;
		b ^= other.b;
		c ^= other.c;
		return *this;
	}
};

hsh rnd() {
	return hsh(tw(), tw(), tw());
}

void solve() {
	int n;
	cin >> n;
	vector<hsh> arr;
	map<int, hsh> vals;
	auto get_val = [&](int num) {
		if (!vals.count(num)) {
			vals[num] = rnd();
		}
		return vals[num];
	};
	for (int i = 0; i < n; ++i) {
		int l, r;
		cin >> l >> r;
		arr.push_back(get_val(l) ^ get_val(r));
	}

	ll ans = 0;
	map<hsh, int> cnt;
	hsh cur;
	for (int i = 0; i < n; ++i) {
		cnt[cur]++;
		cur ^= arr[i];
		ans += cnt[cur];
	}

	cout << ans << "\n";
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}
	
#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}
