// Dmitry _kun_ Sayutin (2019)

#include <bits/stdc++.h>

using std::cin;
using std::cout;
using std::cerr;

using std::vector;
using std::map;
using std::array;
using std::set;
using std::string;
using std::queue;

using std::pair;
using std::make_pair;

using std::tuple;
using std::make_tuple;
using std::get;

using std::min;
using std::abs;
using std::max;
using std::swap;

using std::unique;
using std::sort;
using std::generate;
using std::reverse;
using std::min_element;
using std::max_element;

#ifdef LOCAL
#define LASSERT(X) assert(X)
#else
#define LASSERT(X) {}
#endif

template <typename T>
T input() {
    T res;
    cin >> res;
    LASSERT(cin);
    return res;
}

template <typename IT>
void input_seq(IT b, IT e) {
    std::generate(b, e, input<typename std::remove_reference<decltype(*b)>::type>);
}

#define SZ(vec)         int((vec).size())
#define ALL(data)       data.begin(),data.end()
#define RALL(data)      data.rbegin(),data.rend()
#define TYPEMAX(type)   std::numeric_limits<type>::max()
#define TYPEMIN(type)   std::numeric_limits<type>::min()

std::unordered_map<int64_t, int64_t> cache;

int64_t& cget(int a, int b) {
    return cache[int64_t(a) << int64_t(31) | b];
}

int fpow(int a, int n, int mod) {
    int rs = 1;

    while (n) {
        if (n % 2)
            rs = (rs * int64_t(a)) % mod;

        a = (a * int64_t(a)) % mod;
        n /= 2;
    }

    return rs;
}

bool is_prime(int n) {
    if (n <= 1)
        return false;

    if (n % 2 == 0)
        return (n == 2);

    // fast weak primality check
    static std::mt19937 rnd;
    static std::unordered_map<int, char> prime_cache;    

    char& result = prime_cache[n];
    if (result != 0)
        return result - 1;
    
    for (int i = 0; i < 2; ++i)
        if (fpow(1 + rnd() % (n - 1), n - 1, n) != 1) {
            result = 1;
            return false;
        }

    for (int k = 3; k * k <= n; ++k)
        if (n % k == 0) {
            result = 1;
            return false;
        }

    result = 2;
    return true;
}

int prime_below(int n) {
    while (not is_prime(n))
        --n;

    return n;
}

int64_t get(int a, int b) {
    if (not (a >= b))
        swap(a, b);
    
    if (b == 0) {
        return a * int64_t(a + 1) / 2;
    }
    
    int64_t& result = cget(a, b);
    if (result != 0)
        return result;

    if (is_prime(a)) {
        return result = a + int64_t(b) + int64_t(a == b ? a - 1 : 0);
    }

    if (is_prime(b)) {
        int p = prime_below(a);

        if (p != b and p / b == a / b) {
            return result = a + (int64_t)b;
        }
    }
    
    return result = std::__gcd(a, b) + min(get(a, b - 1), get(a - 1, b));    
}

int main() {
    std::iostream::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    // code here
    int a, b;
    cin >> a >> b;
    cout << get(a, b) << "\n";

    return 0;
}
