// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;
int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }

map<int, bool> primes_mem;

bool is_prime(int num) {
	if (primes_mem.count(num)) {
		return primes_mem[num];
	}
	for (int i = 2; i * i <= num; ++i) {
		if (num % i == 0) {
			return primes_mem[num] = 0;
		}
	}
	return primes_mem[num] = 1;
}

int prev_prime(int num) {
	while (!is_prime(num)) {
		--num;
	}
	return num;
}

map<pii, ll> mem;

void solve() {
	int a, b;
	cin >> a >> b;
	// suppose a <= b
	// answer is a + b if
	// 1) a < b
	// 2.1) b is prime
	//  or
	// 2.2) a is prime and exists a < p <= b (p is prime), such that doesn't exist q \in [p, b] : q divides on a
	function<ll(int, int)> rec = [&](int x, int y) {
		if (x > y) {
			swap(x, y);
		}
		if (x == 0) {
			return (ll) (y + 1) * y / 2;
		}
		if (mem.count({x, y})) {
			return mem[{x, y}];
		}
		if (x == y) {
			return mem[{x, y}] = x + rec(x - 1, y);
		}
		int p = prev_prime(y);
		if (y == p) {
			return mem[{x, y}] = x + y;
		}
		if (is_prime(x) && x < p && p / x == y / x) {
			return mem[{x, y}] = x + y;
		}
		return mem[{x, y}] = __gcd(x, y) + min(rec(x - 1, y), rec(x, y - 1));
	};

	cout << rec(a, b) << "\n";
	// cerr << szof(mem) << endl;
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}
	
#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}
