#include "testlib.h"
#include <set>

using namespace std;

const int MAXN = 100'000;
const int MAXC = 1'000'000'000;

int main(int argc, char* argv[]) {
    registerValidation(argc, argv);

    int n = inf.readInt(1, MAXN, "n");
    inf.readSpace();
    int q = inf.readInt(1, MAXN, "q");
    inf.readEoln();

    set<int> have;

    for (int i = 0; i < n; ++i) {
        if (i > 0) {
            inf.readSpace();
        }
        inf.readInt(1, MAXC, format("a[%d]", i + 1));
        have.insert(i + 1);
    }
    inf.readEoln();

    int c = 1;
    for (int i = 0; i < q; ++i) {
        int t = inf.readInt(1, 3, format("t[%d]", i + 1));
        inf.readSpace();
        if (t == 1) {
            inf.readInt(1, MAXC, format("v[%d]", i + 1));
            have.insert(n + c);
            ++c;
        } else if (t == 2) {
            int v = inf.readInt(1, n + q, format("v[%d]", i + 1));
            ensuref(have.count(v), "operation %d: missing element with index %d", i + 1, v);
            have.erase(v);
        } else if (t == 3) {
            inf.readInt(1, MAXC, format("v[%d]", i + 1));
        }
        inf.readEoln();
    }

    inf.readEof();

    return 0;
}