#include <cmath>
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <list>
#include <time.h>
#include <math.h>
#include <random>
#include <deque>
#include <queue>
#include <cassert>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>
#include <bitset>
#include <sstream>
#include <chrono>
#include <cstring>

using namespace std;

typedef long long ll;

#ifdef iq
  mt19937 rnd(228);
#else
  mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif

const int N = 50;
const int lim = 30;

vector <int> ord;

map <vector <int>, int> dp;

vector <int> ok[lim + 1];
vector <vector <int> > orz;

int ind = 0;

void dfs(int sum, int last) {
  orz.push_back(ord);
  ok[sum].push_back(ind);
  dp[ord] = ind++;
  for (int i = last; sum + i <= lim; i++) {
    ord.push_back(i);
    dfs(sum + i, i);
    ord.pop_back();
  }
}

map <pair <int, int>, int> prec;
set <int> values[N][N];

void build(int n, vector <pair <int, int> > e) {
  dfs(0, 1);
  for (int i = 0; i <= lim; i++) {
    for (int j = 0; i + j <= lim; j++) {
      for (int a : ok[i]) {
        for (int b : ok[j]) {
          if (a > b) continue;
          auto c = orz[a];
          for (int x : orz[b]) c.push_back(x);
          sort(c.begin(), c.end());
          prec[{a, b}] = prec[{b, a}] = dp[c];
        }
      }
    }
  }
  for (int i = 0; i <= n; i++) {
    for (int j = 0; j <= n; j++) {
      values[i][j].clear();
    }
  }
  for (int i = 0; i <= n; i++) {
    values[i][i].insert(0);
  }
  for (int len = 1; len <= n; len++) {
    for (int i = 0; i + len - 1 < n; i++) {
      int j = i + len;
      for (int k = i; k < j; k++) {
        int me = 0;
        for (auto c : e) {
          if (i <= c.first && c.first <= k && k <= c.second && c.second < j) {
            me++;
          }
        }
        int value = dp[{me}];
        for (int x : values[i][k]) {
          for (int y : values[k + 1][j]) {
            int ret = prec[{prec[{x, y}], value}];
            values[i][j].insert(ret);
          }
        }
      }
    }
  }
}

int main() {
#ifdef iq
  freopen("a.in", "r", stdin);
#endif
  ios::sync_with_stdio(0);
  cin.tie(0);
  int n, m;
  cin >> n >> m;
  int q;
  cin >> q;
  vector <pair <int, int> > e;
  for (int i = 0; i < q; i++) {
    int l, r;
    cin >> l >> r;
    l--, r--;
    e.push_back({l, r});
  }
  build(n, e);
  for (int i = 0; i < m; i++) {
    vector <int> a(n);
    for (int &x : a) {
      cin >> x;
    }
    sort(a.rbegin(), a.rend());
    ll ans = 0;
    for (int x : values[0][n]) {
      auto ret = orz[x];
      reverse(ret.begin(), ret.end());
      ll value = 0;
      for (int i = 0; i < (int) ret.size(); i++) {
        value += ret[i] * (ll) a[i];
      }
      ans = max(ans, value);
    }
    cout << ans << '\n';
  }
}
