#include <bits/stdc++.h>
#include "testlib.h"

using namespace std;

inline int readAndCheckAnswer(const string &s, InStream& in) {
    string t = in.readToken();
    if (t == "Impossible")
        return -1;
    string sorted_t = t;
    sort(sorted_t.begin(), sorted_t.end());
    
    string sorted_s = s;
    sort(sorted_s.begin(), sorted_s.end());
    if (sorted_s != sorted_t)
        in.quitf(_wa, "Characters set from input is not equal to output set");

    stack<string> tags;
    int i = 0;
    while (i < int(t.size()))
    {
        if (t[i] != '<')
            in.quitf(_wa, "'<' expected at %d pos, '%c' found", i + 1, t[i]);
        i++;
        
        bool is_close = false;
        if (i < int(t.size()) && t[i] == '/')
            is_close = true, i++;

        string cur = "";
        while (i < int(t.size()) && t[i] >= 'a' && t[i] <= 'z')
            cur += t[i++];

        if (cur.size() == 0) {
            if (i == t.size()) {
                in.quitf(_wa, "Letter expected at %d pos, end of line found", i + 1);
            } else {
                in.quitf(_wa, "Letter expected at %d pos, '%c' found", i + 1, t[i]);
            }
        }
        
        if (i == int(t.size()))
            in.quitf(_wa, "Unexpected end of string");     
        else if (t[i] != '>')
            in.quitf(_wa, "'>' expected at %d pos, '%c' found", i + 1, t[i]);
        i++;
        if (!is_close)
           tags.push(cur);
        else
        {
            if (tags.size() == 0)
                in.quitf(_wa, "Incorrect sequence: Empty stack");
            if (tags.top() != cur)
                in.quitf(_wa, "%s tag expected, %s found", tags.top().c_str(), cur.c_str());
            tags.pop();
        }
    }
    if (tags.size() != 0)
        in.quitf(_wa, "Incorrect sequence: Extra elements on stack in the end");
             
    return 0;
}

int main(int argc, char* argv[]) {
    registerTestlibCmd(argc, argv);

    string s = inf.readToken();

    int ja = readAndCheckAnswer(s, ans);
    int pa = readAndCheckAnswer(s, ouf);

    if(ja != -1 && pa == -1)
        quitf(_wa, "Jury has the answer but participant has not");
    if(ja == -1 && pa != -1)
        quitf(_fail, "Participant has the answer but jury has not");

    quitf(_ok, "|s|=%d", s.size());
}
